Browse Source

Initial commit elemao

Wazakindjes 10 months ago
commit
c540c6d6fa
7 changed files with 1163 additions and 0 deletions
  1. 7 0
      .gitignore
  2. 241 0
      LICENSE
  3. 25 0
      README.me
  4. 2 0
      serbur/killem.sh
  5. 39 0
      serbur/muhconf.ini.example
  6. 416 0
      serbur/srthax_serbur.pl
  7. 433 0
      srthax.pl

+ 7 - 0
.gitignore

@@ -0,0 +1,7 @@
+.DS_Store
+._.*
+$RECYCLE.BIN
+.*.swp
+*-bak*
+*.ini
+/ssl

+ 241 - 0
LICENSE

@@ -0,0 +1,241 @@
+GNU AFFERO GENERAL PUBLIC LICENSE 
+Version 3, 19 November 2007
+Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+
+Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.
+
+Preamble
+
+The GNU Affero General Public License is a free, copyleft license for software and other kinds of works, specifically designed to ensure cooperation with the community in the case of network server software.
+
+The licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, our General Public Licenses are intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users.
+
+When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things.
+
+Developers that use our General Public Licenses protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License which gives you legal permission to copy, distribute and/or modify the software.
+
+A secondary benefit of defending all users' freedom is that improvements made in alternate versions of the program, if they receive widespread use, become available for other developers to incorporate. Many developers of free software are heartened and encouraged by the resulting cooperation. However, in the case of software used on network servers, this result may fail to come about. The GNU General Public License permits making a modified version and letting the public access it on a server without ever releasing its source code to the public.
+
+The GNU Affero General Public License is designed specifically to ensure that, in such cases, the modified source code becomes available to the community. It requires the operator of a network server to provide the source code of the modified version running there to the users of that server. Therefore, public use of a modified version, on a publicly accessible server, gives the public access to the source code of the modified version.
+
+An older license, called the Affero General Public License and published by Affero, was designed to accomplish similar goals. This is a different license, not a version of the Affero GPL, but Affero has released a new version of the Affero GPL which permits relicensing under this license.
+
+The precise terms and conditions for copying, distribution and modification follow.
+
+TERMS AND CONDITIONS
+
+0. Definitions.
+
+"This License" refers to version 3 of the GNU Affero General Public License.
+
+"Copyright" also means copyright-like laws that apply to other kinds of works, such as semiconductor masks.
+
+"The Program" refers to any copyrightable work licensed under this License. Each licensee is addressed as "you". "Licensees" and "recipients" may be individuals or organizations.
+
+To "modify" a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission, other than the making of an exact copy. The resulting work is called a "modified version" of the earlier work or a work "based on" the earlier work.
+
+A "covered work" means either the unmodified Program or a work based on the Program.
+
+To "propagate" a work means to do anything with it that, without permission, would make you directly or secondarily liable for infringement under applicable copyright law, except executing it on a computer or modifying a private copy. Propagation includes copying, distribution (with or without modification), making available to the public, and in some countries other activities as well.
+
+To "convey" a work means any kind of propagation that enables other parties to make or receive copies. Mere interaction with a user through a computer network, with no transfer of a copy, is not conveying.
+
+An interactive user interface displays "Appropriate Legal Notices" to the extent that it includes a convenient and prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work under this License, and how to view a copy of this License. If the interface presents a list of user commands or options, such as a menu, a prominent item in the list meets this criterion.
+
+1. Source Code. 
+The "source code" for a work means the preferred form of the work for making modifications to it. "Object code" means any non-source form of a work.
+
+A "Standard Interface" means an interface that either is an official standard defined by a recognized standards body, or, in the case of interfaces specified for a particular programming language, one that is widely used among developers working in that language.
+
+The "System Libraries" of an executable work include anything, other than the work as a whole, that (a) is included in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves only to enable use of the work with that Major Component, or to implement a Standard Interface for which an implementation is available to the public in source code form. A "Major Component", in this context, means a major essential component (kernel, window system, and so on) of the specific operating system (if any) on which the executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it.
+
+The "Corresponding Source" for a work in object code form means all the source code needed to generate, install, and (for an executable work) run the object code and to modify the work, including scripts to control those activities. However, it does not include the work's System Libraries, or general-purpose tools or generally available free programs which are used unmodified in performing those activities but which are not part of the work. For example, Corresponding Source includes interface definition files associated with source files for the work, and the source code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such as by intimate data communication or control flow between those 
+subprograms and other parts of the work.
+
+The Corresponding Source need not include anything that users can regenerate automatically from other parts of the Corresponding Source.
+
+The Corresponding Source for a work in source code form is that same work.
+
+2. Basic Permissions. 
+All rights granted under this License are granted for the term of copyright on the Program, and are irrevocable provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the unmodified Program. The output from running a covered work is covered by this License only if the output, given its content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as provided by copyright law.
+
+You may make, run and propagate covered works that you do not convey, without conditions so long as your license otherwise remains in force. You may convey covered works to others for the sole purpose of having them make modifications exclusively for you, or provide you with facilities for running those works, provided that you comply with the terms of this License in conveying all material for which you do not control copyright. Those thus making or running the covered works for you must do so exclusively on your behalf, under your direction and control, on terms that prohibit them from making any copies of your copyrighted material outside their relationship with you.
+
+Conveying under any other circumstances is permitted solely under the conditions stated below. Sublicensing is not allowed; section 10 makes it unnecessary.
+
+3. Protecting Users' Legal Rights From Anti-Circumvention Law. 
+No covered work shall be deemed part of an effective technological measure under any applicable law fulfilling obligations under article 11 of the WIPO copyright treaty adopted on 20 December 1996, or similar laws prohibiting or restricting circumvention of such measures.
+
+When you convey a covered work, you waive any legal power to forbid circumvention of technological measures to the extent such circumvention is effected by exercising rights under this License with respect to the covered work, and you disclaim any intention to limit operation or modification of the work as a means of enforcing, against the work's users, your or third parties' legal rights to forbid circumvention of technological measures.
+
+4. Conveying Verbatim Copies. 
+You may convey verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice; keep intact all notices stating that this License and any non-permissive terms added in accord with section 7 apply to the code; keep intact all notices of the absence of any warranty; and give all recipients a copy of this License along with the Program.
+
+You may charge any price or no price for each copy that you convey, and you may offer support or warranty protection for a fee.
+
+5. Conveying Modified Source Versions. 
+You may convey a work based on the Program, or the modifications to produce it from the Program, in the form of source code under the terms of section 4, provided that you also meet all of these conditions:
+
+a) The work must carry prominent notices stating that you modified it, and giving a relevant date.
+
+b) The work must carry prominent notices stating that it is released under this License and any conditions added under section 7. This requirement modifies the requirement in section 4 to "keep intact all notices".
+
+c) You must license the entire work, as a whole, under this License to anyone who comes into possession of a copy. This License will therefore apply, along with any applicable section 7 additional terms, to the whole of the work, and all its parts, regardless of how they are packaged. This License gives no permission to license the work in any other way, but it does not invalidate such permission if you have separately received it.
+
+d) If the work has interactive user interfaces, each must display Appropriate Legal Notices; however, if the Program has interactive interfaces that do not display Appropriate Legal Notices, your work need not make them do so.
+
+A compilation of a covered work with other separate and independent works, which are not by their nature extensions of the covered work, and which are not combined with it such as to form a larger program, in or on a volume of a storage or distribution medium, is called an "aggregate" if the compilation and its resulting copyright are not used to limit the access or legal rights of the compilation's users beyond what the individual works permit. Inclusion of a covered work in an aggregate does not cause this License to apply to the other parts of the aggregate.
+
+6. Conveying Non-Source Forms. 
+You may convey a covered work in object code form under the terms of sections 4 and 5, provided that you also convey the machine-readable Corresponding Source under the terms of this License, in one of these ways:
+
+a) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by the Corresponding Source fixed on a durable physical medium customarily used for software interchange.
+
+b) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by a written offer, valid for at least three years and valid for as long as you offer spare parts or customer support for that product model, to give anyone who possesses the object code either (1) a copy of the Corresponding Source for all the software in the product that is covered by this License, on a durable physical medium customarily used for software interchange, for a price no more than your reasonable cost of physically performing this conveying of source, or (2) access to copy the Corresponding Source from a network server at no charge.
+
+c) Convey individual copies of the object code with a copy of the written offer to provide the Corresponding Source. This alternative is allowed only occasionally and noncommercially, and only if you received the object code with such an offer, in accord with subsection 6b.
+
+d) Convey the object code by offering access from a designated place (gratis or for a charge), and offer equivalent access to the Corresponding Source in the same way through the same place at no further charge. You need not require recipients to copy the Corresponding Source along with the object code. If the place to copy the object code is a network server, the Corresponding Source may be on a different server (operated by you or a third party) that supports equivalent copying facilities, provided you maintain clear directions next to the object code saying where to find the Corresponding Source. Regardless of what server hosts the Corresponding Source, you remain obligated to ensure that it is available for as long as needed to satisfy these requirements.
+
+e) Convey the object code using peer-to-peer transmission, provided you inform other peers where the object code and Corresponding Source of the work are being offered to the general public at no charge under subsection 6d.
+
+A separable portion of the object code, whose source code is excluded from the Corresponding Source as a System Library, need not be included in conveying the object code work.
+
+A "User Product" is either (1) a "consumer product", which means any tangible personal property which is normally used for personal, family, or household purposes, or (2) anything designed or sold for incorporation into a dwelling. In determining whether a product is a consumer product, doubtful cases shall be resolved in favor of coverage. For a particular product received by a particular user, "normally used" refers to a typical or common use of that class of product, regardless of the status of the particular user or of the way in which the particular user actually uses, or expects or is expected to use, the product. A product is a consumer product regardless of whether the product has substantial commercial, industrial or non-consumer uses, unless such uses represent the only significant mode of use of the product.
+
+"Installation Information" for a User Product means any methods, procedures, authorization keys, or other information required to install and execute modified versions of a covered work in that User Product from a modified version of its Corresponding Source. The information must suffice to ensure that the continued functioning of the modified object code is in no case prevented or interfered with solely because modification has been made.
+
+If you convey an object code work under this section in, or with, or specifically for use in, a User Product, and the conveying occurs as part of a transaction in which the right of possession and use of the User Product is transferred to the recipient in perpetuity or for a fixed term (regardless of how the transaction is characterized), the Corresponding Source conveyed under this section must be accompanied by the Installation Information. But this requirement does not apply if neither you nor any third party retains the ability to install modified object code on the User Product (for example, the work has been installed in ROM).
+
+The requirement to provide Installation Information does not include a requirement to continue to provide support service, warranty, or updates for a work that has been modified or installed by the recipient, or for the User Product in which it has been modified or installed. Access to a network may be denied when the modification itself materially and adversely affects the operation of the network or violates the rules and protocols for communication across the network.
+
+Corresponding Source conveyed, and Installation Information provided, in accord with this section must be in a format that is publicly documented (and with an implementation available to the public in source code form), and must require no special password or key for unpacking, reading or copying.
+
+7. Additional Terms. 
+"Additional permissions" are terms that supplement the terms of this License by making exceptions from one or more of its conditions. Additional permissions that are applicable to the entire Program shall be treated as though they were included in this License, to the extent that they are valid under applicable law. If additional permissions apply only to part of the Program, that part may be used separately under those permissions, but the entire Program remains governed by this License without regard to the additional permissions.
+
+When you convey a copy of a covered work, you may at your option remove any additional permissions from that copy, or from any part of it. (Additional permissions may be written to require their own removal in certain cases when you modify the work.) You may place additional permissions on material, added by you to a covered work, for which you have or can give appropriate copyright permission.
+
+Notwithstanding any other provision of this License, for material you add to a covered work, you may (if authorized by the copyright holders of that material) supplement the terms of this License with terms:
+
+a) Disclaiming warranty or limiting liability differently from the terms of sections 15 and 16 of this License; or
+
+b) Requiring preservation of specified reasonable legal notices or author attributions in that material or in the Appropriate Legal Notices displayed by works containing it; or
+
+c) Prohibiting misrepresentation of the origin of that material, or requiring that modified versions of such material be marked in reasonable ways as different from the original version; or
+
+d) Limiting the use for publicity purposes of names of licensors or authors of the material; or
+
+e) Declining to grant rights under trademark law for use of some trade names, trademarks, or service marks; or
+
+f) Requiring indemnification of licensors and authors of that material by anyone who conveys the material (or modified versions of it) with contractual assumptions of liability to the recipient, for any liability that these contractual assumptions directly impose on those licensors and authors.
+
+All other non-permissive additional terms are considered "further restrictions" within the meaning of section 10. If the Program as you received it, or any part of it, contains a notice stating that it is governed by this License along with a term that is a further restriction, you may remove that term. If a license document contains a further restriction but permits relicensing or conveying under this License, you may add to a covered work material governed by the terms of that license document, provided that the further restriction does not survive such relicensing or conveying.
+
+If you add terms to a covered work in accord with this section, you must place, in the relevant source files, a statement of the additional terms that apply to those files, or a notice indicating where to find the applicable terms.
+
+Additional terms, permissive or non-permissive, may be stated in the form of a separately written license, or stated as exceptions; the above requirements apply either way.
+
+8. Termination.
+
+You may not propagate or modify a covered work except as expressly provided under this License. Any attempt otherwise to propagate or modify it is void, and will automatically terminate your rights under this License (including any patent licenses granted under the third paragraph of section 11).
+
+However, if you cease all violation of this License, then your license from a particular copyright holder is reinstated (a) provisionally, unless and until the copyright holder explicitly and finally terminates your license, and (b) permanently, if the copyright holder fails to notify you of the violation by some reasonable means prior to 60 days after the cessation.
+
+Moreover, your license from a particular copyright holder is reinstated permanently if the copyright holder notifies you of the violation by some reasonable means, this is the first time you have received notice of violation of this License (for any work) from that copyright holder, and you cure the violation prior to 30 days after your receipt of the notice.
+
+Termination of your rights under this section does not terminate the licenses of parties who have received copies or rights from you under this License. If your rights have been terminated and not permanently reinstated, you do not qualify to receive new licenses for the same material under section 10.
+
+9. Acceptance Not Required for Having Copies.
+
+You are not required to accept this License in order to receive or run a copy of the Program. Ancillary propagation of a covered work occurring solely as a consequence of using peer-to-peer transmission to receive a copy likewise does not require acceptance. However, nothing other than this License grants you permission to propagate or modify any covered work. These actions infringe copyright if you do not accept this License. Therefore, by modifying or propagating a covered work, you indicate your acceptance of this License to do so.
+
+10. Automatic Licensing of Downstream Recipients.
+
+Each time you convey a covered work, the recipient automatically receives a license from the original licensors, to run, modify and propagate that work, subject to this License. You are not responsible for enforcing compliance by third parties with this License.
+
+An "entity transaction" is a transaction transferring control of an organization, or substantially all assets of one, or subdividing an organization, or merging organizations. If propagation of a covered work results from an entity transaction, each party to that transaction who receives a copy of the work also receives whatever licenses to the work the party's predecessor in interest had or could give under the previous paragraph, plus a right to possession of the Corresponding Source of the work from the predecessor in interest, if the predecessor has it or can get it with reasonable efforts.
+
+You may not impose any further restrictions on the exercise of the rights granted or affirmed under this License. For example, you may not impose a license fee, royalty, or other charge for exercise of rights granted under this License, and you may not initiate litigation (including a cross-claim or counterclaim in a lawsuit) alleging that any patent claim is infringed by making, using, selling, offering for sale, or importing the Program or any portion of it.
+
+11. Patents.
+
+A "contributor" is a copyright holder who authorizes use under this License of the Program or a work on which the Program is based. The work thus licensed is called the contributor's "contributor version".
+
+A contributor's "essential patent claims" are all patent claims owned or controlled by the contributor, whether already acquired or hereafter acquired, that would be infringed by some manner, permitted by this License, of making, using, or selling its contributor version, but do not include claims that would be infringed only as a consequence of further modification of the contributor version. For purposes of this definition, "control" includes the right to grant patent sublicenses in a manner consistent with the requirements of this License.
+
+Each contributor grants you a non-exclusive, worldwide, royalty-free patent license under the contributor's essential patent claims, to make, use, sell, offer for sale, import and otherwise run, modify and propagate the contents of its contributor version.
+
+In the following three paragraphs, a "patent license" is any express agreement or commitment, however denominated, not to enforce a patent (such as an express permission to practice a patent or covenant not to s ue for patent infringement). To "grant" such a patent license to a party means to make such an agreement or commitment not to enforce a patent against the party.
+
+If you convey a covered work, knowingly relying on a patent license, and the Corresponding Source of the work is not available for anyone to copy, free of charge and under the terms of this License, through a publicly available network server or other readily accessible means, then you must either (1) cause the Corresponding Source to be so available, or (2) arrange to deprive yourself of the benefit of the patent license for this particular work, or (3) arrange, in a manner consistent with the requirements of this License, to extend the patent 
+license to downstream recipients. "Knowingly relying" means you have actual knowledge that, but for the patent license, your conveying the covered work in a country, or your recipient's use of the covered work in a country, would infringe one or more identifiable patents in that country that you have reason to believe are valid.
+
+If, pursuant to or in connection with a single transaction or arrangement, you convey, or propagate by procuring conveyance of, a covered work, and grant a patent license to some of the parties receiving the covered work authorizing them to use, propagate, modify or convey a specific copy of the covered work, then the patent license you grant is automatically extended to all recipients of the covered work and works based on it.
+
+A patent license is "discriminatory" if it does not include within the scope of its coverage, prohibits the exercise of, or is conditioned on the non-exercise of one or more of the rights that are specifically granted under this License. You may not convey a covered work if you are a party to an arrangement with a third party that is in the business of distributing software, under which you make payment to the third party based on the extent of your activity of conveying the work, and under which the third party grants, to any of the parties who would receive the covered work from you, a discriminatory patent license (a) in connection with copies of the covered work conveyed by you (or copies made from those copies), or (b) primarily for and in connection with specific products or compilations that contain the covered work, unless you entered into that arrangement, or that patent license was granted, prior to 28 March 2007.
+
+Nothing in this License shall be construed as excluding or limiting any implied license or other defenses to infringement that may otherwise be available to you under applicable patent law.
+
+12. No Surrender of Others' Freedom.
+
+If conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may 
+not convey it at all. For example, if you agree to terms that obligate you to collect a royalty for further conveying from those to whom you convey the Program, the only way you could satisfy both those terms and this License would be to refrain entirely from conveying the Program.
+
+13. Remote Network Interaction; Use with the GNU General Public License.
+
+Notwithstanding any other provision of this License, if you modify the Program, your modified version must prominently offer all users interacting with it remotely through a computer network (if your version supports such interaction) an opportunity to receive the Corresponding Source of your version by providing access to the Corresponding Source from a network server at no charge, through some standard or customary means of facilitating copying of software. This Corresponding Source shall include the Corresponding Source for any work covered by version 3 of the GNU General Public License that is incorporated pursuant to the following paragraph.
+
+Notwithstanding any other provision of this License, you have permission to link or combine any covered work with a work licensed under version 3 of the GNU General Public License into a single combined work, and to convey the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the work with which it is combined will remain governed by version 3 of the GNU General Public License.
+
+14. Revised Versions of this License.
+
+The Free Software Foundation may publish revised and/or new versions of the GNU Affero General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number. If the Program specifies that a certain numbered version of the GNU Affero General Public License "or any later version" applies to it, you have the option of following the terms and conditions either of that numbered version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of the GNU Affero General Public License, you may choose any version ever published by the Free Software Foundation.
+
+If the Program specifies that a proxy can decide which future versions of the GNU Affero General Public License can be used, that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the Program.
+
+Later license versions may give you additional or different permissions. However, no additional obligations are imposed on any author or copyright holder as a result of your choosing to follow a later version.
+
+15. Disclaimer of Warranty.
+
+THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+16. Limitation of Liability.
+
+IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
+
+17. Interpretation of Sections 15 and 16.
+
+If the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of the Program in return for a fee.
+
+END OF TERMS AND CONDITIONS
+
+How to Apply These Terms to Your New Programs
+
+If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.
+
+To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively state the exclusion of warranty; and each file should have at least the "copyright" line and a pointer to where the full notice is found.
+
+<one line to give the program's name and a brief idea of what it does.> 
+Copyright (C) <year> <name of author>
+
+This program is free software: you can redistribute it and/or modify 
+it under the terms of the GNU Affero General Public License as published by 
+the Free Software Foundation, either version 3 of the License, or 
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful, 
+but WITHOUT ANY WARRANTY; without even the implied warranty of 
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+GNU Affero General Public License for more details.
+
+You should have received a copy of the GNU Affero General Public License 
+along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If your software can interact with users remotely through a computer network, you should also make sure that it provides a way for users to get its source. For example, if your program is a web application, its interface could display a "Source" link that leads users to an archive of the code. There are many ways you could offer source, and different solutions will be better for different programs; see section 13 for the specific requirements.
+
+You should also get your employer (if you work as a programmer) or school, if any, to sign a "copyright disclaimer" for the program, if necessary. For more information on this, and how to apply and follow the GNU AGPL, see <http://www.gnu.org/licenses/>.

+ 25 - 0
README.me

@@ -0,0 +1,25 @@
+# The fuck is this
+This shit allows you to correct the timestamps within subtitle files (`.srt` only lol). ;;];]]; As a b0nus, it also converts the files to use Linux-style line endings, cuz many are uploaded with Wind0ngs ones instead. It also shits out a bunch of warnings to help ya find inconsistencies within em subs y0.
+
+Besides the main skrip, there's also a "server" thingy which I'm using from my [k0di](https://gitgud.malvager.net/Wazakindjes/k0di) app so I can easily correct subs as I watch some shit. [=[[=[==[=[=[
+
+# Dependencies
+__srthax itself:__
+* `Data::Dumper`
+* `File::Slurp`
+* `Getopt::Mixed`
+
+__The server script:__
+* `Config::IniFiles`
+* `Data::Dumper`
+* `File::Basename`
+* `IO::Handle`
+* `IO::Select`
+* `IO::Socket::INET`
+* `IO::Socket::SSL`
+
+# Usage
+`srthax [options] <time shift> <.srt file(s)>`
+__Due to how `Getopt::Mixed` works, if you want a negative time shift make sure to terminate the arguments with `--`:__ `srthax -o -- -10 poop.srt`
+
+Simply run `srthax --halp` to view the built-in halp and see all the supported options. ;] The server doesn't take any arguments but works with a config file. Just copy `serbur/muhconf.ini.example` to `serbur/muhconf.ini` and edit that shit, everything's explained in thur. ;];]];;] It also doesn't log anything by itself, all info is printed to stdout so you can do whatever you want with it. =] This also means it runs in the foreground and you should probably just run it within `screen`/`tmux`.

+ 2 - 0
serbur/killem.sh

@@ -0,0 +1,2 @@
+#!/bin/bash
+kill -INT $(ps aux | grep [p]erl.*srthax_serbur.pl | awk '{print $2}')

+ 39 - 0
serbur/muhconf.ini.example

@@ -0,0 +1,39 @@
+[main]
+	# Address and port to bind to, prolly want 0.0.0.0 to listen on all interfaces ;]
+	addy = 0.0.0.0
+	port = 6971
+
+	# How many clients can exist in the _connection queue_ (so not active clients)
+	backlog = 5
+
+	# If an accept() call takes longer than this, abort that shit
+	accept_timeout = 10
+
+	# Clients should authenticate within this interval (seconds too lol)
+	auth_timeout = 10
+
+	# Ping timeout for clients
+	client_timeout = 120
+
+	# SSL shit
+	cert = /home/hecks/srthax/ssl/srthax.crt
+	key = /home/hecks/srthax/ssl/srthax.key
+	ca_dir = /etc/ssl/certs
+
+	# Authentication key, should be 64 chars (unless changed in the Perl)
+	auth = abcdefghijklmnopqrstuvwwxyz1234567890ABCDEFGHIJKKLMNOPQRSTUVWXYZ
+
+	# If set to 1 there's no authentication =]
+	debug = 0
+
+	# Difference with debug is that verbose doesn't alter functionality ;]
+	verbose = 0
+
+	# Full path to srthax.pl main script
+	srthax = /home/hecks/srthax/srthax.pl
+
+	# Passed as-is to srthax.pl ;]
+	srthax_opts = -o
+
+	# Subtitle files should all be contained in one directory and should match the name of the video they belong to ;]
+	subtitle_dir = /mnt/subtitles

+ 416 - 0
serbur/srthax_serbur.pl

@@ -0,0 +1,416 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use threads;
+use threads::shared;
+
+use Config::IniFiles;
+use Data::Dumper;
+use File::Basename;
+use IO::Handle;
+use IO::Select;
+use IO::Socket::INET;
+use IO::Socket::SSL;
+
+# Better not touch these niQQa ;]
+my $MUHVERSION = '1.0';
+my $PING_NOAUTH = -3;
+my $PING_DED = -2;
+my $PING_EXIT = -1;
+my $AUTHLEN = 64;
+my $AUTHREGEX = "[A-Za-z0-9]{$AUTHLEN}";
+my %CONF;
+my $KBAI = 0;
+
+$SIG{INT} = sub {
+	printem("Received SIGINT, cleaning up that shit lol");
+	$KBAI = 1;
+};
+
+$SIG{TERM} = sub {
+	printem("Received SIGTERM, cleaning up that shit lol");
+	$KBAI = 1;
+};
+
+my @checkem_main = (
+	'addy', 'port', 'backlog', 'accept_timeout', 'auth_timeout', 'client_timeout', 'cert', 'key',
+	'ca_dir', 'auth', 'debug', 'verbose', 'srthax', 'srthax_opts', 'subtitle_dir',
+);
+
+my $srthax; # Full path to srthax.pl main skrip
+my $srthax_opts;
+my $subtitle_dir;
+my $selectem; # IO select for multiplexing em connections
+my %ping; # Keep tracc of connection status
+my %clients; # Keep track of em sockets too
+
+my $srv;
+
+# ohboyherewego.bmp
+sub printem {
+	my ($msg, $tabs) = @_;
+	return if(!defined($msg) || $msg =~ /^\s*$/);
+	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
+	my $tiemstampus = sprintf("[%02d/%02d/%04d %02d:%02d:%02d] ", $mday, $mon + 1, $year + 1900, $hour, $min, $sec);
+	my @msgs = split(/[\r\n]+/, $msg);
+	$tabs = (defined($tabs) && $tabs =~ /^\d+$/ && $tabs > 0 ? $tabs : 0);
+	foreach my $m(@msgs) {
+		print $tiemstampus;
+		print "    " for(1...$tabs);
+		print "$m\r\n";
+	}
+}
+
+sub sockprint {
+	my ($sock, $msg) = @_;
+	print $sock "$msg\r\n";
+}
+
+sub trimmem {
+	no warnings 'uninitialized';
+	my $str = shift;
+	$str =~ s/(^\s+|\s+$)//g;
+	return $str;
+}
+
+# Convert multiple of the same config directives into 1 line for ez parsing ;;]];];;];];]
+sub parseconf_multiline {
+	no warnings 'uninitialized';
+	my $v = shift;
+	$v =~ s/[\r\n]+/,/g;
+	$v =~ s/,{2,}/,/g;
+	my @tmp = split(/\s*,\s*/, $v);
+	return @tmp;
+}
+
+sub read_conf {
+	# Read config val00s first, parse/check laturd imo (so we can cross-check shit if necessary lol)
+	my $dirname = dirname(__FILE__);
+	my $cfg = Config::IniFiles->new(-file => "$dirname/muhconf.ini");
+	foreach my $ckey(@checkem_main) {
+		$CONF{$ckey} = $cfg->val('main', $ckey) || '';
+	}
+}
+
+sub check_conf {
+	# Now actually czech em conf imo
+	my $wegucci = 1;
+
+	foreach my $k(keys(%CONF)) {
+		my $v = $CONF{$k};
+		if($k eq 'addy') {
+			if(!length($v)) {
+				printem("Value for '$k' is missing entirely");
+				$wegucci = 0;
+			}
+			# Let IO::Socket rep0rt address errors so we can support all formats ;]
+		}
+		elsif($k eq 'port') {
+			if($v !~ /^\d+$/ || $v <= 1024 || $v >= 65535) {
+				printem("Value for '$k' must be an integer larger than 1024 and less than 65535: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k =~ /^(backlog|client_timeout)$/) {
+			if($v !~ /^\d+$/ || $v == 0) {
+				printem("Value for '$k' must be an integer larger than 0: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k =~ /^(accept|auth)_timeout$/) {
+			if($v !~ /^\d+$/ || $v == 0 || $v > 10) {
+				printem("Value for '$k' must be an integer larger than 0 and equal to or less than 10: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k eq 'cert') {
+			if(! -e $v || ! -f $v || ! -r $v) {
+				printem("Certificate file does not exist, is not a regular file or is not readable: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k eq 'key') {
+			if(! -e $v || ! -f $v || ! -r $v) {
+				printem("Key file does not exist, is not a regular file or is not readable: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k eq 'ca_dir') {
+			if(! -e $v || ! -d $v || ! -r $v) {
+				printem("CA cert directory does not exist or is not readable: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k eq 'auth') {
+			if($v !~ /^$AUTHREGEX$/) {
+				printem("Auth key should be exactly $AUTHLEN chars in length: $v (" . length($v) . ' chars)');
+				$wegucci = 0;
+			}
+		}
+		elsif($k =~ /^(debug|verbose)$/) {
+			$CONF{$k} = ((defined($v) && $v) ? 1 : 0);
+		}
+		elsif($k eq 'srthax') {
+			if(! -e $v || ! -f $v || ! -r $v || ! -x $v) {
+				printem("srthax main script path does not exist, is not a regular file or is not readable/executable: $v");
+				$wegucci = 0;
+			}
+		}
+		elsif($k eq 'srthax_opts') {
+			# Essa optional, no need to czech the value either cuz srthax.pl itself vill do dat ;]
+		}
+		elsif($k eq 'subtitle_dir') {
+			if(! -e $v || ! -d $v || ! -r $v || ! -x $v || ! -w $v) {
+				printem("Subtitle path does not exist, is not a directory or is not readable/writable: $v");
+				$wegucci = 0;
+			}
+		}
+		else {
+			printem("Unknown config directive lol: main::$k");
+		}
+	}
+
+	return $wegucci;
+}
+
+sub setup_srthax {
+	# Hardly a setup function but whatevs :DDD
+	$srthax = $CONF{srthax};
+	$srthax_opts = $CONF{srthax_opts};
+	$subtitle_dir = $CONF{subtitle_dir};
+}
+
+sub setup_socket {
+	$srv = IO::Socket::SSL->new(
+		LocalAddr => $CONF{addy},
+		LocalPort => $CONF{port},
+		Proto => 'tcp',
+		Listen => $CONF{backlog},
+		SSL_cert_file => $CONF{cert},
+		SSL_key_file => $CONF{key},
+		ReuseAddr => 1,
+		ReusePort => 1,
+		Timeout => $CONF{accept_timeout},
+	) or die($!);
+
+	# Just in case lol
+	binmode($srv, ':utf8');
+	$srv->autoflush(1);
+
+	# Cuz we gonna do select shit and not multithreadin ;]
+	$selectem = IO::Select->new($srv);
+}
+
+sub cleanup_socket {
+	my $indent = 0;
+	if($KBAI) {
+		$indent = 1;
+	}
+
+	if(%clients) {
+		printem("Cleaning up clients y0", $indent);
+		foreach my $ckey(keys(%clients)) {
+			my $client = ${$clients{$ckey}->{sock}};
+			printem("Client: $ckey", $indent + 1) if($CONF{verbose});
+			sockprint($client, "[KBAI] Server is shutting down lmao");
+			$selectem->remove($client); # Prolly not necessary, but let's just for good measure ;]];;];
+			$client->shutdown(2);
+			$client->close;
+			delete($clients{$ckey}); # Safe to do because we're doing keys(%clients), which returns an array and is thus a different entity ;]
+			delete($ping{$ckey});
+		}
+	}
+
+	printem("Shutting down master socket", $indent);
+	$srv->close;
+}
+
+sub srthaxem {
+	my $args = shift;
+	my $start = $args->{start};
+	my $timeshift = $args->{timeshift};
+	my $subname = ($args->{subname});
+	my $tabs = $args->{tabs} || 0;
+
+	$subname =~ s/\.[A-Za-z0-9]+$/.srt/;
+
+	my $haxout = trimmem(`$srthax $srthax_opts --start $start -- $timeshift "$subtitle_dir/$subname" 2>&1`);
+	if($haxout =~ /\[(ERROR|WARN)\]/) {
+		printem("Got an error from srthax: $haxout", $tabs);
+		return { err => 1, msg => $haxout };
+	}
+
+	return { err => 0 };
+}
+
+sub main_lewp {
+	my $readtimeout = pack('qq', 1, 0); # Read timeout for client sockets is 1 sec so it matches can_read() and won't cause the entire fucking server to hang
+
+	while(1) {
+		my %readfrom = (); # Cuz only increment pings for clients who didn't send shit 0bv ;]
+		MAIN: while(my @ready = $selectem->can_read(1)) { # Poll every second yo
+			foreach my $client(@ready) {
+				if($client == $srv) { # Master socket also counts towards can_read(), which happens when a new client connects
+					my $new = $srv->accept;
+					next if(!$new);
+					my $ckey = $new->peerhost . ':' . $new->peerport; # Client host and port is used as a key for many of them hashes
+					$selectem->add($new); # Add to select0r handle
+					IO::Handle::blocking($new, 0); # Gotta set it to non-blocking so it doesn't block other clients xd
+					printem("($ckey) New connection");
+					$new->sockopt(SO_RCVTIMEO, $readtimeout);
+
+					# Initialise some shit imo
+					$clients{$ckey} = { sock => \$new, auth => $CONF{debug} };
+					$ping{$ckey} = 0;
+					$readfrom{$ckey} = 0;
+					next;
+				}
+
+				my $read = 0; # Suddenly disconnected clients still return tru for can_read(), so gotta make sure we _actually_ read something
+				my $ckey = $client->peerhost . ':' . $client->peerport;
+				while(my $buf = <$client>) {
+					$buf =~ s/(^[\r\n]+|[\r\n]+$)//g; # Cuz chomp() seems to fuck with nullbytes
+					if($buf =~ /^\s*$/) {
+						# Fucking hack for the client to test if the socket is still good
+						$read = 2 if($read == 0);
+						last;
+					}
+					printem("($ckey) '$buf'") if($CONF{verbose} || $buf !~ /^!ping/i);
+					$read = 1; # Actually got some data lol
+
+					# Check if auth is (still) needed
+					if(!$clients{$ckey}->{auth}) {
+						# Unauthed clients can only do !auth 0bv 0bv
+						if($buf =~ /^!a(?:uth)?(?: ($AUTHREGEX))?/i) {
+							if(defined($1) && $1 eq $CONF{'auth'}) {
+								$clients{$ckey}->{auth} = 1;
+								sockprint($client, "Accepted authentication");
+								printem("Accepted key", 1);
+								next;
+							}
+							sockprint($client, "Rejected authentication");
+							printem("Invalid key", 1);
+						}
+						else {
+							sockprint($client, "Authentication required");
+						}
+						$ping{$ckey} = $PING_NOAUTH;
+						last;
+					}
+
+					# Usable commands go hur ;];]
+					if($buf =~ /^!ping/i) {
+						next;
+					}
+
+					if($buf =~ /^!a(?:uth)?/i) {
+						# In case of duplicate commands, simply emit a warning (also cuz le Android app always sends the command even if the server is in debug m0de ;])
+						sockprint($client, "Accepted authentication (already authorised)");
+						printem("Accepted key (already authorised)", 1);
+						next;
+					}
+
+					if($buf =~ /^!(q(uit)?|e(xit)?)$/i) {
+						# $PING_EXIT makes this shit do a clean close() =]]
+						$ping{$ckey} = $PING_EXIT;
+						last MAIN;
+					}
+
+					# Let's do a "naive" check for arguments, since srthax.pl itself handles all czechs [=[=[=[=[=[=[=[
+					if($buf =~ /^!srthax ([\d:]+) (-?[\d.]+) (.+)/i) {
+						my $start = $1;
+						my $timeshift = $2;
+						my $subname = $3;
+
+						my $srtres = srthaxem({ start => $start, timeshift => $timeshift, subname => $subname });
+						if($srtres->{err}) {
+							sockprint($client, $srtres->{msg});
+						}
+						else {
+							# Send an empty string so the client won't wait for a reply ;];;];];];];]];];];];;];]];
+							sockprint($client, "");
+						}
+						next;
+					}
+				}
+
+				# Let's not forget to reset em ping on any command ;];];;]];
+				if($read > 0) {
+					$readfrom{$ckey} = $read;
+				}
+				else {
+					$ping{$ckey} = $PING_DED;
+					last MAIN; # Required so we won't go into an infinite loop using 100% CPU lmao
+				}
+			}
+		}
+
+		last if($KBAI);
+
+		# Increment pings where necessary
+		foreach my $ckey(keys(%clients)) {
+			if(exists($readfrom{$ckey})) {
+				my $kek = $readfrom{$ckey};
+				delete($readfrom{$ckey});
+				if($kek == 1 && $ping{$ckey} >= 0) {
+					$ping{$ckey} = 0;
+					next;
+				}
+			}
+
+			# Shit's < 0 on error, otherwise it must exceed certain thresh0lds
+			if($ping{$ckey} < 0 || ++$ping{$ckey} >= $CONF{client_timeout} || (!$clients{$ckey}->{auth} && $ping{$ckey} >= $CONF{auth_timeout})) {
+				my $client = ${$clients{$ckey}->{sock}};
+				$selectem->remove($client);
+				if($ping{$ckey} > 0) { # Ping or auth timeout y0
+					my $werd = 'Ping';
+					my $werdlc = 'ping';
+					my $werdto = $CONF{client_timeout};
+					if(!$clients{$ckey}->{auth}) {
+						$werd = 'Auth';
+						$werdlc = 'auth';
+						$werdto = $CONF{auth_timeout};
+					}
+					sockprint($client, "$werd timeout lol");
+					printem("($ckey) Closed connection due to $werdlc timeout ($ping{$ckey} >= $werdto)");
+				}
+				elsif($ping{$ckey} == $PING_EXIT) {
+					printem("Cleaning up socket", 1);
+				}
+				elsif($ping{$ckey} == $PING_DED) {
+					printem("($ckey) Cleaning up supposedly dead socket");
+				}
+				elsif($ping{$ckey} == $PING_NOAUTH) {
+					printem("Cleaning up unauthorised socket", 1);
+				}
+				$client->shutdown(2);
+				$client->close;
+				delete($clients{$ckey});
+				delete($ping{$ckey});
+				delete($readfrom{$ckey});
+			}
+		}
+	}
+}
+
+printem("Ayy starting up: v$MUHVERSION");
+printem("Gonna read em config y0");
+read_conf();
+exit 1 if(!check_conf());
+printem("We gucci mane", 1);
+
+printem("RUNNING IN DEBUG MODE (NO AUTH REQUIRED)") if($CONF{debug});
+
+setup_srthax();
+
+printem("Setting up master socket");
+setup_socket();
+
+printem("Starting main lewp");
+main_lewp();
+
+printem("Cleaning up master socket");
+cleanup_socket();
+
+printem("KBAI LOL");
+print "\r\n";

+ 433 - 0
srthax.pl

@@ -0,0 +1,433 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+
+use Data::Dumper;
+use File::Slurp;
+use Getopt::Mixed;
+
+use constant VERSION => '1.0';
+
+sub printem {
+	my $obj = shift;
+	return if(!defined($obj));
+
+	my $reftype = ref($obj);
+	if($reftype eq 'ARRAY') {
+		print Dumper(@{$obj});
+	}
+	elsif($reftype eq 'HASH') {
+		print Dumper(%{$obj});
+	}
+	else {
+		print $obj;
+	}
+	print "\r\n";
+}
+
+sub fuckoff {
+	my $msg = shift;
+	printem($msg) if(defined($msg) && length($msg));
+	exit(1);
+}
+
+sub printem_halp {
+	printem_version();
+	printem('This shit allows you to correct the timestamps within subtitle files (.srt only lol) ;;];]];');
+	printem('As a b0nus, it also converts the .srt files to use Linux-style line endings, cuz many are uploaded with Wind0ngs ones instead');
+	printem('It also shits out a bunch of warnings to help ya find inconsistencies within em subs y0');
+	printem('');
+	printem('Usage: srthax [options] <time shift> <.srt file(s)>');
+	printem('');
+	printem('Time shift is in seconds and supports a resolution of 1 ms (+0.001) as well as negative numbahs');
+	printem('Options:');
+	printem('	--halp, --help, -h');
+	printem('	--version');
+	printem('');
+	printem('	--overwrite, -o');
+	printem('		Update the files in-place, otherwise they\'re saved as <basename>-hax.srt');
+	printem('	--start [HH:]MM:SS[,ms], -s [HH:]MM:SS[,ms]');
+	printem('		Only modify subtitles from this point on (inclusive), hours and milliseconds are optional');
+	printem('		Keep in mind that [,ms] is the literal amount of milliseconds, so 01:23,45 would be: 1 minute, 23 seconds, 45 milliseconds (*not* 450 ms, i.e. it\'s not a decimal)');
+	printem('	--verbose, -v');
+}
+
+sub printem_version {
+	printem('srthax v' . VERSION);
+}
+
+sub checkem_timestring_quad {
+	my $timestr = shift || '';
+	if($timestr !~ /^([+-])?(?:(\d{2}):)?(?:(\d{2}))(?::(\d{2}))(?:,(\d{1,3}))?$/) {
+		return undef;
+	}
+	my $sign = $1 || '';
+	my $h = $2;
+	my $m = $3;
+	my $s = $4;
+	my $ms = $5;
+	return gib_ms($timestr, $sign, $h, $m, $s, $ms, 0);
+}
+
+sub gib_ms {
+	my ($timestr, $sign, $match_h, $match_m, $match_s, $match_ms, $fatal) = @_;
+	my $h = 0;
+	my $m = 0;
+	my $s = 0;
+	my $ms = 0;
+	$sign = '' if($sign ne '-');
+
+	# No checks required, although idk how .srt files work with hours beyond 24 xd
+	if(defined($match_h)) {
+		$h = ($match_h * (60 * 60 * 1000));
+	}
+
+	# Even though minutes and seconds are required, let's just keep the code style consistent for all of em ;]
+	if(defined($match_m)) {
+		if($m >= 60) {
+			if($fatal) {
+				fuckoff("[ERROR] Ayy invalid timestring y0: $timestr (minutes can't be equal to or greater than 60 fam)");
+			}
+			printem("[WARN] Ayy invalid timestring y0: $timestr (minutes can't be equal to or greater than 60 fam)");
+			return undef;
+		}
+		$m = ($match_m * (60 * 1000));
+	}
+
+	if(defined($match_s)) {
+		if($s >= 60) {
+			if($fatal) {
+				fuckoff("[ERROR] Ayy invalid timestring y0: $timestr (seconds can't be equal to or greater than 60 fam)");
+			}
+			printem("[WARN] Ayy invalid timestring y0: $timestr (seconds can't be equal to or greater than 60 fam)");
+			return undef;
+		}
+		$s = ($match_s * 1000);
+	}
+
+	if(defined($match_ms)) {
+		if($ms >= 1000) {
+			if($fatal) {
+				fuckoff("[ERROR] Ayy invalid timestring y0: $timestr (milliseconds can't be equal to or greater than 1000 fam)");
+			}
+			printem("[WARN] Ayy invalid timestring y0: $timestr (milliseconds can't be equal to or greater than 1000 fam)");
+			return undef;
+		}
+		$ms = $match_ms;
+	}
+
+	return sprintf('%s%d', $sign, ($h + $m + $s + $ms));
+}
+
+sub gib_timestring_quad {
+	my ($ms, $timeshift_ms) = @_;
+	if(!defined($ms) || !defined($timeshift_ms) || $ms !~ /^[+-]?\d+$/ || $timeshift_ms !~ /^[+-]?\d+$/) {
+		return undef;
+	}
+
+	my $sign = '';
+	$ms += $timeshift_ms;
+
+	if($ms < 0.0) {
+		$sign = '-';
+		$ms = abs($ms);
+	}
+
+	my $s = int($ms / 1000);
+	$ms = ($ms % 1000);
+
+	my $m = int($s / 60);
+	$s = ($s % 60);
+
+	my $h = int($m / 60);
+	$m = ($m % 60);
+
+	return sprintf('%s%02d:%02d:%02d,%03d', $sign, $h, $m, $s, $ms);
+}
+
+sub mainlol {
+	Getopt::Mixed::init(
+		# *n0* leading spaec for the first wun lmao
+		'halp help>halp h>halp' .
+		' overwrite o>overwrite' .
+		' start=s s>start' . # Only check shit from this point on (HH:MM:SS)
+		' verbose v>verbose' .
+		' version' .
+	''); # Ending with '' here so every line above can end with a period ;];];];]];;]
+
+	my ($opt_overwrite, $opt_start_ms, $opt_verbose);
+	while(my($opt, $val) = Getopt::Mixed::nextOption()) {
+		OPTION: {
+			$opt eq 'halp' && do {
+				printem_halp();
+				fuckoff();
+			};
+
+			$opt eq 'version' && do {
+				printem_version();
+				fuckoff();
+			};
+
+			$opt eq 'overwrite' && do {
+				$opt_overwrite = 1;
+				last OPTION;
+			};
+
+			$opt eq 'start' && do {
+				$opt_start_ms = checkem_timestring_quad($val);
+				if(!defined($opt_start_ms)) {
+					fuckoff("[ERROR] Ayy invalid time string y0: $val");
+				}
+				last OPTION;
+			};
+
+			$opt eq 'verbose' && do {
+				$opt_verbose = 1;
+				last OPTION;
+			};
+		}
+	}
+	Getopt::Mixed::cleanup();
+
+	$opt_start_ms = 0 if(!defined($opt_start_ms));
+
+	if(scalar(@ARGV) < 2) {
+		fuckoff('[ERROR] Not enough arguments: time shift value and .srt files are required y0');
+	}
+
+	my $arg_timeshift = shift(@ARGV);
+	if($arg_timeshift !~ /^([+-])?(\d+)(?:\.(\d{1,3}))?$/) {
+		fuckoff("[ERROR] Invalid time shift value: $arg_timeshift (must be of the format [+|-]SS[.ms])");
+	}
+	my $timeshift_sign = $1 || '';
+	my $match_timeshift_s = $2;
+	my $match_timeshift_ms = $3;
+
+	if(defined($match_timeshift_ms)) {
+		$match_timeshift_ms .= '0' x (3 - length($match_timeshift_ms));
+	}
+
+	my $timeshift_ms = gib_ms($arg_timeshift, $timeshift_sign, undef, undef, $match_timeshift_s, $match_timeshift_ms, 1);
+
+	if($timeshift_ms == 0.0) {
+		fuckoff("[ERROR] Invalid time shift value: $arg_timeshift (must be non-zero)");
+	}
+
+	my $srt_count = 0;
+	CHECKEM_SRT: foreach my $srtpath(@ARGV) {
+		printem('') if($opt_verbose && $srt_count > 0);
+
+		if(! -e $srtpath) {
+			printem("[ERROR] .srt path doesn't exist: $srtpath");
+			next;
+		}
+		if(! -f $srtpath) {
+			printem("[ERROR] .srt path is not a regular file: $srtpath");
+			next;
+		}
+
+		if($srtpath !~ /\.srt$/i) {
+			printem("[ERROR] Ayy not een .srt file l0l: $srtpath");
+			next;
+		}
+
+		printem("Ayy checkin: $srtpath") if($opt_verbose);
+
+		my @lines = ();
+		eval {
+			my $data = read_file($srtpath);
+			@lines = split(/^/m, $data);
+		};
+		if($@) {
+			if($opt_verbose) {
+				# Already printed the srt path ab0ve when in verb0se m00d ;]
+				printem("[ERROR] Got error while reading em file, skipping em: $@");
+				next;
+			}
+			else {
+				printem("[ERROR] Got error while reading em file, skipping em ($srtpath): $@");
+				next;
+			}
+		}
+
+		my ($has_linenumber, $has_timestamps);
+		my @lines_new = ();
+		for(my $i = 1; $i <= scalar(@lines); $i++) {
+			# Not doing a foreach lewp cuz we may need to store the indices of entries to rem0ve lol
+			# Also starting with $i = 1 for ez printing [=[[===[=[
+			my $line = $lines[$i - 1];
+			$line =~ s/[\r\n]+//g;
+
+			# First should be the line number
+			if($line =~ /^\d+$/) {
+				if($has_linenumber) {
+					# Duplicate number lol (without shit inbetween etc)
+					if($opt_verbose) {
+						printem("[WARN] Found successive line numbers (around line $i)");
+					}
+					else {
+						printem("[WARN] Found successive line numbers for file: $srtpath (around line $i)");
+					}
+				}
+
+				$has_linenumber = 1;
+				push(@lines_new, $line);
+				next;
+			}
+
+			if($line =~ /^([+-]?[\d:,]+) --> ([+-]?[\d:,]+)$/) {
+				my $match_timestamp_start = $1;
+				my $match_timestamp_end = $2;
+
+				if($has_timestamps) {
+					if($opt_verbose) {
+						printem("[WARN] Found successive time stamps (around line $i)");
+					}
+					else {
+						printem("[WARN] Found successive time stamps for file: $srtpath (around line $i)");
+					}
+				}
+				$has_timestamps = 1;
+
+				my ($timestamp_start_ms, $timestamp_end_ms);
+				$timestamp_start_ms = checkem_timestring_quad($match_timestamp_start);
+				if(!defined($timestamp_start_ms)) {
+					if($opt_verbose) {
+						printem("[WARN] Invalid time string (around line $i)");
+					}
+					else {
+						printem("[WARN] Invalid time string for file: $srtpath (around line $i)");
+					}
+					push(@lines_new, $line);
+					next;
+				}
+
+				$timestamp_end_ms = checkem_timestring_quad($match_timestamp_end);
+				if(!defined($timestamp_end_ms)) {
+					if($opt_verbose) {
+						printem("[WARN] Invalid time string (around line $i)");
+					}
+					else {
+						printem("[WARN] Invalid time string for file: $srtpath (around line $i)");
+					}
+					push(@lines_new, $line);
+					next;
+				}
+
+				my $timestamp_start = gib_timestring_quad($timestamp_start_ms, $timeshift_ms);
+				if(!defined($timestamp_start)) {
+					if($opt_verbose) {
+						printem("[WARN] Invalid resulting start timestring '$match_timestamp_start' (around line $i)");
+					}
+					else {
+						printem("[WARN] Invalid resulting start timestring '$match_timestamp_start' for file: $srtpath (around line $i)");
+					}
+					push(@lines_new, $line);
+					next;
+				}
+
+				my $timestamp_end = gib_timestring_quad($timestamp_end_ms, $timeshift_ms);
+				if(!defined($timestamp_end)) {
+					if($opt_verbose) {
+						printem("[WARN] Invalid resulting end timestring '$match_timestamp_end' (around line $i)");
+					}
+					else {
+						printem("[WARN] Invalid resulting end timestring '$match_timestamp_end' for file: $srtpath (around line $i)");
+					}
+					push(@lines_new, $line);
+					next;
+				}
+
+				if($opt_start_ms > 0 && $timestamp_start_ms < $opt_start_ms) {
+					push(@lines_new, $line);
+					next;
+				}
+
+				push(@lines_new, "$timestamp_start --> $timestamp_end");
+				next;
+			}
+
+			# Anything else should be all-text, or empty for separating lines/paragraphs
+			if(!$has_linenumber || !$has_timestamps) {
+				# Obviously we need the other 2 variables first ;]
+				if($opt_verbose) {
+					printem("[WARN] Apparently reached text section but found no preceeding timestamps or line number (around line $i)");
+				}
+				else {
+					printem("[WARN] Apparently reached text section but found no preceeding timestamps or line number for file: $srtpath (around line $i)");
+				}
+			}
+
+			if(length($line) == 0) {
+				$has_linenumber = 0;
+				$has_timestamps = 0;
+			}
+
+			push(@lines_new, $line);
+		}
+
+		if(!scalar(@lines_new)) {
+			if($opt_verbose) {
+				printem("[WARN] Ayy no new data to write lol, skipping em file");
+			}
+			else {
+				printem("[WARN] Ayy no new data to write lol, skipping em file ($srtpath)");
+			}
+			next;
+		}
+
+		# Always use the -hax file as tempfile for writing, then move it over the existing file if --overwrite is specified ;]
+		my $new_srtpath = $srtpath;
+		$new_srtpath =~ s/(\.[A-Za-z]+)$/-hax$1/;
+
+		if($opt_verbose) {
+			if($opt_overwrite) {
+				printem("Ayy writing tempfile: $new_srtpath");
+			}
+			else {
+				printem("Ayy writing new file: $new_srtpath");
+			}
+		}
+
+		eval {
+			@lines = write_file($new_srtpath, (join("\n", @lines_new) . "\n"));
+		};
+		if($@) {
+			if($opt_verbose) {
+				# Already printed the srt path ab0ve when in verb0se m00d ;]
+				printem("[ERROR] Got error while writing em tempfile, skipping em: $@");
+				next;
+			}
+			else {
+				printem("[ERROR] Got error while writing em tempfile, skipping em ($srtpath): $@");
+				next;
+			}
+		}
+
+		if($opt_overwrite) {
+			if($opt_verbose) {
+				printem("Ayy renaming tempfile to original");
+			}
+			if(!rename($new_srtpath, $srtpath)) {
+				if($opt_verbose) {
+					# Already printed the srt path ab0ve when in verb0se m00d ;]
+					printem("[ERROR] Unable to rename em tempfile, original .srt file may or may not be fucked lol");
+					next;
+				}
+				else {
+					printem("[ERROR] Unable to rename em tempfile, original .srt file may or may not be fucked lol ($srtpath)");
+					next;
+				}
+			}
+		}
+
+		if($opt_verbose) {
+			printem("Ayy dunz0");
+		}
+		$srt_count++;
+	}
+
+	printem("Successfully br0cessed $srt_count .srt file(s) l0l");
+}
+
+mainlol();